<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfMapItem_V2 ArrayType
 * @subpackage Arrays
 */
class ArrayOfMapItem_V2 extends AbstractStructArrayBase
{
    /**
     * The MapItem_V2
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\MapItem_V2[]
     */
    public $MapItem_V2;
    /**
     * Constructor method for ArrayOfMapItem_V2
     * @uses ArrayOfMapItem_V2::setMapItem_V2()
     * @param \StructType\MapItem_V2[] $mapItem_V2
     */
    public function __construct(array $mapItem_V2 = array())
    {
        $this
            ->setMapItem_V2($mapItem_V2);
    }
    /**
     * Get MapItem_V2 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\MapItem_V2[]|null
     */
    public function getMapItem_V2()
    {
        return isset($this->MapItem_V2) ? $this->MapItem_V2 : null;
    }
    /**
     * This method is responsible for validating the values passed to the setMapItem_V2 method
     * This method is willingly generated in order to preserve the one-line inline validation within the setMapItem_V2 method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateMapItem_V2ForArrayConstraintsFromSetMapItem_V2(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfMapItem_V2MapItem_V2Item) {
            // validation for constraint: itemType
            if (!$arrayOfMapItem_V2MapItem_V2Item instanceof \StructType\MapItem_V2) {
                $invalidValues[] = is_object($arrayOfMapItem_V2MapItem_V2Item) ? get_class($arrayOfMapItem_V2MapItem_V2Item) : sprintf('%s(%s)', gettype($arrayOfMapItem_V2MapItem_V2Item), var_export($arrayOfMapItem_V2MapItem_V2Item, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The MapItem_V2 property can only contain items of type \StructType\MapItem_V2, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set MapItem_V2 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\MapItem_V2[] $mapItem_V2
     * @return \ArrayType\ArrayOfMapItem_V2
     */
    public function setMapItem_V2(array $mapItem_V2 = array())
    {
        // validation for constraint: array
        if ('' !== ($mapItem_V2ArrayErrorMessage = self::validateMapItem_V2ForArrayConstraintsFromSetMapItem_V2($mapItem_V2))) {
            throw new \InvalidArgumentException($mapItem_V2ArrayErrorMessage, __LINE__);
        }
        if (is_null($mapItem_V2) || (is_array($mapItem_V2) && empty($mapItem_V2))) {
            unset($this->MapItem_V2);
        } else {
            $this->MapItem_V2 = $mapItem_V2;
        }
        return $this;
    }
    /**
     * Add item to MapItem_V2 value
     * @throws \InvalidArgumentException
     * @param \StructType\MapItem_V2 $item
     * @return \ArrayType\ArrayOfMapItem_V2
     */
    public function addToMapItem_V2(\StructType\MapItem_V2 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\MapItem_V2) {
            throw new \InvalidArgumentException(sprintf('The MapItem_V2 property can only contain items of type \StructType\MapItem_V2, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->MapItem_V2[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\MapItem_V2|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\MapItem_V2|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\MapItem_V2|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\MapItem_V2|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\MapItem_V2|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string MapItem_V2
     */
    public function getAttributeName()
    {
        return 'MapItem_V2';
    }
}
